//Тест MCP23017
//#include "RT_HW_Main.h"
#include "RT_HW_MCP23017.h" //Включает #include "RT_HW_Wire.h"
//++++++++Выбор параметров под тип контроллера
#if defined (__AVR_ATmega328__) || defined (__AVR_ATmega328P__)  || defined(__AVR_ATmega2560__)  || defined(__AVR_ATmega2561__) || defined(__SAM3X8E__)
  enum {pinControl=13,pinBack=12, pinFast=11, pinEvent=10};    
#elif defined(ESP8266) || defined(ESP32)
  enum {pinControl=2,pinBack=16, pinFast=14, pinEvent=12}; 
#elif defined(_VARIANT_ARDUINO_STM32_) 
  enum {pinControl=PA0, pinBack=PA1, pinFast=PA2, pinEvent=PA3}; 
#else
  enum {pinControl=13,pinBack=12, pinFast=11, pinFast=10};   
#endif 
//=================================================== 
RT_HW_MCP23017_DEVICE     z1;   
//RT_HW_MCP23017_ID     mcp1;    
int16_t addr1=0x20; //0x20 шестнадцатиричный или 32 десятичный
bool blink,bl2,bl3,eventBack,eventFast,eventTic;
uint16_t cntBack,cntFast;
uint32_t timeStart1,timeStart2,timeStart3;
uint8_t outA=0x55;
uint8_t outB=0xAA;
uint8_t inA=0;
uint8_t inB=0;
//void printInput(){Serial.println("device="+ String(z1.device)+" vA="+String(z1.valA,HEX)+" vB="+String(z1.valB, HEX));}
//---------------------------------------
void setup(){Serial.begin(115200);
pinMode(pinControl,OUTPUT); pinMode(pinFast,OUTPUT); pinMode(pinBack,OUTPUT); pinMode(pinEvent,OUTPUT);
Wire.begin(); 
}
//---------------------------------------
void loop() {
//======Системная часть===============================
blink=!blink;
cntBack++; if(cntBack>100) {cntBack=0; eventBack=1;} else  eventBack=0; //--Формирование флага фоновой задачи
cntFast++; if(cntFast>1000){cntFast=0; eventFast=1;} else  eventFast=0; //--Формирование флага быстрой задачи
digitalWrite(pinControl,blink); digitalWrite(pinBack,eventBack); 
//digitalWrite(pinFast,eventFast); digitalWrite(pinEvent,z1.event); 
//======Быстрая задача=================================
if(eventFast){}
//======Фоновая задача================================= 
if(eventBack){
if(RT_HW_mcp23017.event_ms(timeStart2,200)) {if(bl2) {bl2=0; outA=0x55;} else{bl2=1; outA=0xAA;} } 
if(RT_HW_mcp23017.event_ms(timeStart3,1000)){if(bl3) {bl3=0; outB=0x55;} else{bl3=1; outB=0xAA;} }  
//outB=z1.inA;
//++++ Блок инициализации и контроля дисплея begin(). Параметры ->lcd,id,col,row,addr;     
RT_HW_mcp23017.begin(z1);
switch(z1.dir){default: case 1: break;  case 0: RT_HW_mcp23017.setID_device(z1,addr1,'O','O',1); break; 
case 2: RT_HW_mcp23017.makeRun_device (z1,5); RT_HW_mcp23017.device(z1,outA,outB); break;}}
//----------------------------------------------------
} // end loop()
//====================================================
